# Letter Count Bar Chart

In this demo, we asynchronously load a text file, use JavaScript to count the number of times each letter appears in that file, and generate a bar chart showing the letter count in [D3.js](http://d3js.org/) v5.

This is meant to be an introductory demo to expose students to [HTML](https://developer.mozilla.org/en-US/docs/Web/HTML), [CSS](https://developer.mozilla.org/en-US/docs/Web/CSS), [SVG](https://developer.mozilla.org/en-US/docs/Web/SVG), [JavaScript](https://developer.mozilla.org/en-US/docs/Web/JavaScript), [D3](http://d3js.org/), [Bl.ocks](http://bl.ocks.org/), [Blockbuilder](http://blockbuilder.org/), and [VizHub](https://vizhub.com/) for the first time.

## References

This example can be found at: [Gist](https://gist.github.com/sjengle/01c24c71016a97938beae8c778c15911), [Bl.ocks](https://bl.ocks.org/sjengle/01c24c71016a97938beae8c778c15911), [Blockbuilder](https://blockbuilder.org/sjengle/01c24c71016a97938beae8c778c15911), [VizHub](https://vizhub.com/sjengle/c31dc3533020482bae433ac86bf231df)

The starter template for this example can be found at: [Gist](https://gist.github.com/sjengle/bd5ba3847e0d65af55e85b75aa5c0f73)

See the Wikipedia page [Peter Piper Nursery Rhyme](https://en.wikipedia.org/wiki/Peter_Piper) for the origins behind the text used in this example.

## Inspirations

This example has undergone multiple iterations:

  - Using Observable Notebook and D3v5: <https://observablehq.com/d/28ba93f58fb82f49>
  - Using Bl.ocks and D3v5: <https://bl.ocks.org/sjengle/1e23258249638a508426470a48ff2924>
  - Using Bl.ocks and D3v3: <https://bl.ocks.org/sjengle/e8c0d6abc0a8d52d4b11>

Below you can find videos related to an older version of this example. Please note that some content was discussed in-class only:

  - [Letter Count Bar Chart - Scales](https://youtu.be/DiFxUr5OY68)
  - [Letter Count Bar Chart - Enter](https://youtu.be/uSS2awybX78)

The original inspirations come from the following excellent tutorials on creating a bar chart in D3 for the first time:

  - [D3 Bar Chart](https://observablehq.com/@d3/bar-chart) by Mike Bostock, Observable Notebook using D3v5, published on November 2017.

  - [Let's Make a Bar Chart](http://bost.ocks.org/mike/bar/) by Mike Bostock, Blog Post using D3v3, published on November 2013.

  - [Making a Bar Chart](https://alignedleft.com/tutorials/d3/making-a-bar-chart) by Scott Murray, Blog Post using D3v3, updated on December 2018.
